com.jnape.palatable.lambda.functions.builtin.fn2

## Class Into4<A,B,C,D,E>

- java.lang.Object
- - com.jnape.palatable.lambda.functions.builtin.fn2.Into4<A,B,C,D,E>

- Type Parameters:
    `A` - the first argument type
    `B` - the second argument type
    `C` - the third argument type
    `D` - the fourth argument type
    `E` - the result type
  All Implemented Interfaces:
    Fn1<Fn4<? super A,? super B,? super C,? super D,? extends E>,Fn1<Product4<A,B,C,D>,E>>, Fn2<Fn4<? super A,? super B,? super C,? super D,? extends E>,Product4<A,B,C,D>,E>, Applicative<Fn1<Product4<A,B,C,D>,E>,Fn1<Fn4<? super A,? super B,? super C,? super D,? extends E>,?>>, Cartesian<Fn4<? super A,? super B,? super C,? super D,? extends E>,Fn1<Product4<A,B,C,D>,E>,Fn1<?,?>>, Cocartesian<Fn4<? super A,? super B,? super C,? super D,? extends E>,Fn1<Product4<A,B,C,D>,E>,Fn1<?,?>>, Contravariant<Fn4<? super A,? super B,? super C,? super D,? extends E>,Profunctor<?,Fn1<Product4<A,B,C,D>,E>,Fn1<?,?>>>, Functor<Fn1<Product4<A,B,C,D>,E>,Fn1<Fn4<? super A,? super B,? super C,? super D,? extends E>,?>>, Profunctor<Fn4<? super A,? super B,? super C,? super D,? extends E>,Fn1<Product4<A,B,C,D>,E>,Fn1<?,?>>, Monad<Fn1<Product4<A,B,C,D>,E>,Fn1<Fn4<? super A,? super B,? super C,? super D,? extends E>,?>>, MonadReader<Fn4<? super A,? super B,? super C,? super D,? extends E>,Fn1<Product4<A,B,C,D>,E>,Fn1<Fn4<? super A,? super B,? super C,? super D,? extends E>,?>>, MonadRec<Fn1<Product4<A,B,C,D>,E>,Fn1<Fn4<? super A,? super B,? super C,? super D,? extends E>,?>>, MonadWriter<Fn4<? super A,? super B,? super C,? super D,? extends E>,Fn1<Product4<A,B,C,D>,E>,Fn1<Fn4<? super A,? super B,? super C,? super D,? extends E>,?>>

      public final class Into4<A,B,C,D,E>
      extends Object
      implements Fn2<Fn4<? super A,? super B,? super C,? super D,? extends E>,Product4<A,B,C,D>,E>

  Given an ``Fn4`<A, B, C, D, E>` and a ``Product4`<A, B, C, D>`, destructure the product and apply the slots as arguments to the function, returning the result.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Into4()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `E` | `checkedApply(Fn4<? super A,? super B,? super C,? super D,? extends E> fn, Product4<A,B,C,D> product)`
    `static <A,B,C,D,E> Into4<A,B,C,D,E>` | `into4()`
    `static <A,B,C,D,E> Fn1<Product4<A,B,C,D>,E>` | `into4(Fn4<? super A,? super B,? super C,? super D,? extends E> fn)`
    `static <A,B,C,D,E> E` | `into4(Fn4<? super A,? super B,? super C,? super D,? extends E> fn, Product4<A,B,C,D> product)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `apply, apply, checkedApply, compose, contraMap, curried, curry, diMapL, discardR, flip, fn2, fromBiFunction, toBiFunction, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Constructor Detail

    - #### Into4

          public Into4()

  - ### Method Detail

    - #### checkedApply

          public E checkedApply(Fn4<? super A,? super B,? super C,? super D,? extends E> fn,
                                Product4<A,B,C,D> product)

      Specified by:
        `checkedApply` in interface `Fn2<Fn4<? super A,? super B,? super C,? super D,? extends E>,Product4<A,B,C,D>,E>`

    - #### into4

          public static <A,B,C,D,E> Into4<A,B,C,D,E> into4()

    - #### into4

          public static <A,B,C,D,E> Fn1<Product4<A,B,C,D>,E> into4(Fn4<? super A,? super B,? super C,? super D,? extends E> fn)

    - #### into4

          public static <A,B,C,D,E> E into4(Fn4<? super A,? super B,? super C,? super D,? extends E> fn,
                                            Product4<A,B,C,D> product)